#!/bin/bash
#--------------------------------------------------------
#Trouve les points saillants pour une sequence d'images
#et effectue la mise en correspondance avec les
#programme sift et match de David Lowe
#
#Jean-Philippe Tardif
#version 1, Janver 2007
#
#usage: ./sift_match [source_images/] [% pour la mise a l'échelle, entre 0 et 100]
#utilise les images commencant par 0 avec extension jpg
#en ordre lexicographique
#--------------------------------------------------------


DATA=$1
SCALE=$2"%"


i=0
for f in $DATA/0*jpg;
  do 
  a=$(printf "%s/%03d" $DATA $i)
  printf "convert %s to %s.pgm with scale=%s\n" $f $a $SCALE
  convert -scale $SCALE $f $a.pgm
  ((i=i+1))
done

((n=i))
((n2=n-1))


for i in `seq 1 $n`;
  do
  a=$(printf "%s/%03d" $DATA $i)
  ./sift < $a.pgm > $a.key;
done    


for i in `seq 1 $n2`;
  do
  ((i2=i+1))
  a=$(printf "%s/%03d" $DATA $i)
  a2=$(printf "%s/%03d" $DATA $i2)
  out=$(printf "%s/match-%03d-%03d-math.data" $DATA $i $i2)
  printf "matching %s %s to %s\n" $a $a2 $out
  ./match -im1 $a.pgm -k1 $a.key -im2 $a2.pgm -k2 $a2.key  > $out
done  
